SystemOrganization addCategory: #'CAs-Pirate-Gui'!

BlocketRootMorph subclass: #PirateEpisodeMorph
	instanceVariableNames: 'model allTorrents torrents listIndex torrentsSwe listIndexSwe listIndexInvalids'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CAs-Pirate-Gui'!

!PirateEpisodeMorph methodsFor: 'initialization' stamp: 'ChristerAssmundsson 4/7/2015 07:18'!
addControls
	| r lst btnPanel |
	self addMorphBack: (StringMorph contents: 'Title: ').	"self
	addMorph: (PluggableTextMorph
	on: nil
	text: #getTitle
	accept: #setTitle)."
	lst := PluggableMultiColumnListMorph
		on: self
			list: #list
			selected: #listIndex
			changeSelected: #listIndex:.
	lst doubleClickSelector: #dblClick;
		wrapSelector: #getTorrentText:;
		color: Color white;
		extent: 500 @ 130.	"		menu: #listMenu:."
	self addMorphBack: lst.
	lst := PluggableMultiColumnListMorph
		on: self
		list: #listSwe
		selected: #listIndexSwe
		changeSelected: #listIndexSwe:.	"		menu: #listMenu:."
	lst doubleClickSelector: #dblClick.
	lst wrapSelector: #getTorrentText:.
	lst color: Color white.
	lst extent: 500 @ 130.
	self addMorphBack: lst.
	btnPanel := self newRow.
	btnPanel
		color: Color transparent;
		borderWidth: 0;
		layoutInset: 2;
		wrapCentering: #center;
		cellPositioning: #topCenter;
		hResizing: #shrinkWrap;
		vResizing: #shrinkWrap;
		extent: 5 @ 5.
	self addMorphBack: btnPanel.
	btnPanel addMorphBack: (self newButton: 'Refresh.' do: #refreshTorrents).
	btnPanel addMorphBack: (self newButton: 'Eztv' do: #eztvTorrents).
	btnPanel addMorphBack: (self newButton: 'Download' do: #download).
	btnPanel addMorphBack: (self newButton: 'Remove files' do: #removeFiles).
	btnPanel addMorphBack: (self newButton: 'Set Torrent' do: #setTorrent).
	btnPanel addMorphBack: (self newButton: 'Subtitles...' do: #subtitles).
	btnPanel addMorphBack: (self newButton: 'findTorrent.' do: #findCurrentTorrent).
	btnPanel addMorphBack: (self newButton: 'Invalid Torrent' do: #invalidTorrent).
	lst := PluggableMultiColumnListMorph
		on: self
		list: #listInvalids
		selected: #listIndexInvalids
		changeSelected: #listIndexInvalids:
		menu: #listMenu:.
	lst doubleClickSelector: #dblClickInvalids.
	lst wrapSelector: #getTorrentText:.
	lst color: Color gray.
	lst extent: 500 @ 130.
	self addMorphBack: lst.
	self addMorphBack: (self newButton: 'Remove invalid' do: #removeInvalid).	"------------------------------------"
	r := AlignmentMorph newRow
		color: Color transparent;
		borderWidth: 0;
		layoutInset: 0.
	r
		wrapCentering: #center;
		cellPositioning: #topCenter;
		hResizing: #shrinkWrap;
		vResizing: #shrinkWrap;
		extent: 5 @ 5.
	r addMorphBack: (self newButton: 'Close' do: #delete).
	r addTransparentSpacerOfSize: 8 @ 0.
	self addMorphFront: r! !

!PirateEpisodeMorph methodsFor: 'events' stamp: 'CAs 7/28/2012 08:52'!
dblClick
	self setTorrent.
	self delete.! !

!PirateEpisodeMorph methodsFor: 'events' stamp: 'CAs 6/19/2012 23:01'!
download
	model isDownloaded
		ifFalse: [model download]
		ifTrue: [^ self]! !

!PirateEpisodeMorph methodsFor: 'dropping/grabbing' stamp: 'CAs 6/23/2012 10:36'!
dropFiles: anEvent 
| |
	Transcript show: 'Dropped files';cr.
	
"	numFiles := anEvent contents.
	1 to: numFiles do: [ :i |
		(stream := FileStream requestDropStream: i) ifNotNil: [
			handler := ExternalDropHandler lookupExternalDropHandler: stream.
			[ handler ifNotNil: [handler handle: stream in: self dropEvent: anEvent ] ]
				ensure: [ stream close ] ] ]."

	^self.! !

!PirateEpisodeMorph methodsFor: 'events' stamp: 'ChristerAssmundsson 4/7/2015 07:19'!
eztvTorrents! !

!PirateEpisodeMorph methodsFor: 'events' stamp: 'CAs 6/22/2012 11:13'!
findCurrentTorrent
	| torrent m |
	torrent := model magnet.
	torrent isEmptyOrNil
		ifTrue: [^ self].
	1
		to: torrents size
		do: [:i | 
			m := torrents at: i.
			torrent
					= (m at: 2)
				ifTrue: [self listIndex: i]].
1
		to: torrentsSwe size
		do: [:i | 
			m := torrentsSwe at: i.
			torrent
					= (m at: 2)
				ifTrue: [self listIndexSwe:i]].
! !

!PirateEpisodeMorph methodsFor: 'model access' stamp: 'ChristerAssmundsson 1/31/2014 23:19'!
getTorrentText: aTorrent
	aTorrent class =String ifTrue: [^aTorrent].
	^ {aTorrent at: 1. (aTorrent at: 3) asString. (aTorrent at: 4) asString}! !

!PirateEpisodeMorph methodsFor: 'events' stamp: 'ChristerAssmundsson 9/3/2012 07:28'!
getTorrents
	| |
	model
		ifNil: [^ self].
	[allTorrents := model torrents.
	torrents :=allTorrents
				reject: [:i | (i at: 1)
						includesSubstring: 'swesub'
						caseSensitive: false].
	self changed: #list.
	listIndex := 0.
	torrentsSwe := allTorrents
				select: [:i | (i at: 1)
						includesSubstring: 'swesub'
						caseSensitive: false].
	self changed: #listSwe.
	listIndexSwe := 0.
	self changed: #listInvalids.
	listIndexInvalids := 0.
	WorldState
		addDeferredUIMessage: [self findCurrentTorrent]] fork! !

!PirateEpisodeMorph methodsFor: 'initialization' stamp: 'CAs 7/6/2012 09:34'!
initialize
	model := nil.
	super initialize.
"	self enableDrop: true."
"	self highlightForDrop"! !

!PirateEpisodeMorph methodsFor: 'events' stamp: 'ChristerAssmundsson 9/3/2012 07:28'!
invalidTorrent
	 | t |
	self listIndex > 0
		ifTrue: [t := torrents at: listIndex].
	self listIndexSwe > 0
		ifTrue: [t := torrentsSwe at: listIndexSwe].
	t isNil
		ifFalse: [model addFalseTorrent: t.
			self getTorrents]! !

!PirateEpisodeMorph methodsFor: 'model access' stamp: 'CAs 7/9/2012 02:47'!
list
	| |
	torrents
		ifNil: [^ nil].
	torrents isEmpty
		ifTrue: [^ nil].
	
	"^ #(1 3 4 )
		collect: [:f | torrents
				collect: [:i | i at: f]]"
			^torrents! !

!PirateEpisodeMorph methodsFor: 'model access' stamp: 'CAs 5/17/2012 21:42'!
listIndex
	^ listIndex
		ifNil: [listIndex := 0]! !

!PirateEpisodeMorph methodsFor: 'model access' stamp: 'ChristerAssmundsson 4/7/2015 07:12'!
listIndex: aSmallInteger
	listIndex := aSmallInteger.
	self changed: #listIndex.
	listIndexSwe := 0.
	self changed: #listIndexSwe! !

!PirateEpisodeMorph methodsFor: 'model access' stamp: 'ChristerAssmundsson 9/3/2012 07:26'!
listIndexInvalids
	^ listIndexInvalids
		ifNil: [listIndexInvalids := 0]! !

!PirateEpisodeMorph methodsFor: 'model access' stamp: 'ChristerAssmundsson 4/7/2015 07:13'!
listIndexInvalids: aSmallInteger
	listIndexInvalids := aSmallInteger.
	self changed: #listIndex! !

!PirateEpisodeMorph methodsFor: 'model access' stamp: 'CAs 6/22/2012 00:08'!
listIndexSwe
	^ listIndexSwe
		ifNil: [listIndexSwe := 0]! !

!PirateEpisodeMorph methodsFor: 'model access' stamp: 'ChristerAssmundsson 4/7/2015 07:12'!
listIndexSwe: aSmallInteger
	listIndexSwe := aSmallInteger.
	self changed: #listIndexSwe.
	listIndex := 0.
	self changed: #listIndex! !

!PirateEpisodeMorph methodsFor: 'model access' stamp: 'ChristerAssmundsson 9/3/2012 07:25'!
listInvalids
	model 
		ifNil: [^ nil].
	model falseTorrents isEmpty
		ifTrue: [^ nil].
	^model falseTorrents! !

!PirateEpisodeMorph methodsFor: 'model access' stamp: 'CAs 7/22/2012 10:32'!
listSwe
	| |
	torrentsSwe
		ifNil: [^ nil].
	torrentsSwe isEmpty
		ifTrue: [^ nil].

"	^ #(1 3 4 )
		collect: [:f | torrentsSwe
				collect: [:i | i at: f]]."
			^torrentsSwe! !

!PirateEpisodeMorph methodsFor: 'model access' stamp: 'ChristerAssmundsson 9/3/2012 07:27'!
model: anEpisode 
	model := anEpisode.
	self getTorrents! !

!PirateEpisodeMorph methodsFor: 'events' stamp: 'ChristerAssmundsson 1/31/2014 23:50'!
refreshTorrents
	model lookForIt. 
	self getTorrents.! !

!PirateEpisodeMorph methodsFor: 'events' stamp: 'CAs 6/19/2012 22:06'!
removeFiles

	model isDownloaded
		ifTrue: [model removeTorrentAndData]
		ifFalse: [^ self]! !

!PirateEpisodeMorph methodsFor: 'events' stamp: 'ChristerAssmundsson 9/3/2012 07:30'!
removeInvalid
	 | t |
	self listIndexInvalids > 0
		ifTrue: [t := model falseTorrents at: listIndexInvalids].
	t isNil
		ifFalse: [model removeFalseTorrent: t.
			self getTorrents]! !

!PirateEpisodeMorph methodsFor: 'events' stamp: 'ChristerAssmundsson 9/9/2012 09:33'!
setTorrent
	| t |
	self listIndex > 0
		ifTrue: [t := torrents at: listIndex].
	self listIndexSwe > 0
		ifTrue: [t := torrentsSwe at: listIndexSwe].
	t isNil
		ifFalse: [model torrent: t;
				 download.
				self listIndexSwe > 0
					ifTrue: [model setSub: 'dummy'].]! !

!PirateEpisodeMorph methodsFor: 'events' stamp: 'ChristerAssmundsson 11/3/2012 20:44'!
subtitles
| m |
m:=PirateSubtitleMorph new.

			m model: ( model).
			m openInWorld! !

!PirateEpisodeMorph methodsFor: 'dropping/grabbing' stamp: 'CAs 6/23/2012 10:35'!
wantsDropFiles: anEvent 
	^ true! !

!PirateEpisodeMorph methodsFor: 'dropping/grabbing' stamp: 'CAs 7/11/2012 20:25'!
wantsDroppedMorph: aMorph event: anEvent
	^false! !

BlocketRootMorph subclass: #PirateManagerMorph
	instanceVariableNames: 'list listIndex model listIndex2 model2 model3 listIndex3'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CAs-Pirate-Gui'!

!PirateManagerMorph methodsFor: 'initialize-release' stamp: 'ChristerAssmundsson 4/3/2015 10:36'!
addControls
	| bb r lst lst2 lst3 r1 r2 r3 r1c2 r2c2 r3c2 listboxWidth |
	listboxWidth := 350.
	r1 := self newRow.
	r1c2 := r1 class newColumn.
	r2 := self newRow.
	r2c2 := r1 class newColumn.
	r3 := self newRow.
	r3c2 := r1 class newColumn.
	lst := PluggableMultiColumnListMorph
		on: self
		list: #list
		selected: #listIndex
		changeSelected: #listIndex:.	"	menu: #listMenu:."
	lst doubleClickSelector: #dblClick.
	lst wrapSelector: #getShowText:.
	lst color: Color white.
	lst extent: listboxWidth @ 230.
	r1 addMorphBack: lst.
	r1c2 addMorphBack: (self newButton: 'Add show...' do: #addShow).
	r1c2 addMorphBack: (self newButton: 'Add EZTV...' do: #addEztv).
	r1c2 addMorphBack: (self newButton: 'Look for new' do: #lookForNew).
	r1c2 addMorphBack: (self newButton: 'Remove seen' do: #removeSeen).
	r1c2 addMorphBack: (self newButton: 'Write to file' do: #writeToFile).
	r1c2 addMorphBack: (self newButton: 'Archive...' do: #archiveShow).
	r1c2 addMorphBack: (self newButton: 'Delete show...' do: #deleteShow).
	r1c2 addMorphBack: (self newButton: 'Refresh' do: #refresh).
	r1c2 addMorphBack: (self newButton: 'New episodes' do: #newEpisodes).
	r1c2 addMorphBack: (self newButton: 'Viewables' do: #viewables).
	r1c2 addMorphBack: (self newButton: 'Needs torrent' do: #needsTorrent).
	r1c2 addMorphBack: (self newButton: 'Pairing' do: #pairing).
	r1 addMorphBack: r1c2.
	lst2 := PluggableListMorph
		on: self
		list: #list2
		selected: #listIndex2
		changeSelected: #listIndex2:.
	lst2 doubleClickSelector: #dblClick2.
	lst2 wrapSelector: #getSeasonText:.
	lst2 color: Color white.
	lst2 extent: listboxWidth @ 150.
	r2 addMorphBack: lst2.
	r2c2 addMorphBack: (self newButton: 'Add Season...' do: #addSeason).
	r2 addMorphBack: r2c2.
	lst3 := PluggableMultiColumnListMorph
		on: self
		list: #list3
		selected: #listIndex3
		changeSelected: #listIndex3:
		menu: #listMenu3:.
	lst3 doubleClickSelector: #dblClick3.
	lst3 wrapSelector: #getEpisodeText:.
	lst3 color: Color white.
	lst3 extent: listboxWidth @ 200.
	r3 addMorphBack: lst3.
	r3c2 addMorphBack: (self newButton: 'Open' do: #dblClick3).
	r3c2 addMorphBack: (self newButton: 'Add episode' do: #addEpisode).
	r3c2 addMorphBack: (self newButton: 'Add episodes...' do: #addEpisodes).
	r3c2 addMorphBack: (self newButton: 'Remove episode...' do: #removeEpisode).
	r3c2 addMorphBack: (self newButton: 'Play !!!!' do: #play).
	r := AlignmentMorph newRow
		color: Color transparent;
		borderWidth: 0;
		layoutInset: 0.
	r3c2 addMorphBack: (self newButton: 'Seen' do: #seenEpisode).
	r := AlignmentMorph newRow
		color: Color transparent;
		borderWidth: 0;
		layoutInset: 0.
	r3c2 addMorphBack: (self newButton: 'Add videofile' do: #addVideofile).
	r3c2 addMorphBack: (self newButton: 'Add Torrent' do: #addTorrent).
	r3 addMorphBack: r3c2.
	r
		wrapCentering: #center;
		cellPositioning: #topCenter;
		hResizing: #shrinkWrap;
		vResizing: #shrinkWrap;
		extent: 5 @ 5.
	bb := SimpleButtonMorph new
		target: self;
		borderColor: Color black.
	r
		addMorphBack:
			(self
				wrapperFor:
					(bb
						label: 'Close' translated;
						actionSelector: #delete)).
	r addTransparentSpacerOfSize: 8 @ 0.
	self addMorphBack: r1.
	self addMorphBack: r2.
	self addMorphBack: r3.
	self addMorphFront: r! !

!PirateManagerMorph methodsFor: 'event handling' stamp: 'CAs 5/25/2012 06:31'!
addEpisode
	listIndex2 > 0
		ifFalse: [^ self].
	model3 addEpisode.
	self changed: #list3.
! !

!PirateManagerMorph methodsFor: 'event handling' stamp: 'CAs 7/10/2012 08:33'!
addEpisodes
		| maxNo |
	listIndex2 > 0
		ifFalse: [^ self].
		maxNo:= UIManager default request: 'Max episode number' initialAnswer: '1'.
		maxNo isNil ifTrue:[^self].
		maxNo := maxNo asInteger.
		(1+model3 maxEpisode) to: maxNo do: [:i|model3 addEpisodeNo: i] .

	self changed: #list3.
! !

!PirateManagerMorph methodsFor: 'event handling' stamp: 'ChristerAssmundsson 4/3/2015 10:42'!
addEztv
	| show id |
	listIndex = 0
		ifTrue: [ ^ self ].
	show := self list at: listIndex.
	id := UIManager default request: 'Add EZTV id:' initialAnswer: show eztv printString.
	id isNil
		ifTrue: [ ^ self ].
	show eztv: id.
	self changed: #list! !

!PirateManagerMorph methodsFor: 'event handling' stamp: 'CAs 5/25/2012 07:12'!
addSeason
	model2 addSeason.self changed: #list2.
			listIndex2 := 0.
			self changed: #listIndex2.
			model3 := nil.
			self changed: #list3! !

!PirateManagerMorph methodsFor: 'event handling' stamp: 'CAs 7/10/2012 18:25'!
addShow
	| name sh |
	name := UIManager default request: 'Name of new show'.
	name isEmpty
		ifFalse: [sh := PirateShow new.    
			"UserDialogBoxMorph inform: name."
			sh name: name.
			self changed: #list.
			listIndex := 0.
			self changed: #listIndex2.
			model3 := nil.
			self changed: #list3]! !

!PirateManagerMorph methodsFor: 'event handling' stamp: 'ChristerAssmundsson 3/18/2015 21:18'!
addTorrent
	| t mag ep |
	listIndex3 = 0
		ifTrue: [ ^ self ].
	mag := UIManager default request: 'Add torrent (Magnet link):' initialAnswer: '<Magnet link>'.
	mag isNil
		ifTrue: [ ^ self ].
	t := PirateTorrent magnet: mag.
	t isNil
		ifTrue: [ ^ self ].
	ep := model3 episodes at: listIndex3.
	ep
		torrent: t;
		download.
	self changed: #list3! !

!PirateManagerMorph methodsFor: 'event handling' stamp: 'ChristerAssmundsson 3/31/2015 18:33'!
addVideofile
	| ep file vf |
	listIndex3 = 0 
		ifTrue: [ ^ self ].
file:=UITheme current 	chooseFileIn: self title: 'Select a video file' extensions: nil path: PirateTorrent folder preview: nil.
	file isNil
		ifTrue: [ ^ self ].
	self halt.
	vf := PirateVideoFile new.
	vf videoFilename: file basename.
	vf folder: file reference parent fullName.
	ep := model3 episodes at: listIndex3.
	ep
		videoFile: vf.
	self changed: #list3! !

!PirateManagerMorph methodsFor: 'event handling' stamp: 'ChristerAssmundsson 5/18/2014 08:52'!
archiveShow
	listIndex > 0
		ifTrue: [ 
			(self confirm: 'Vill du verkligen arkivera programmet?' , String crlfcrlf , (self list at: listIndex) name)
				ifTrue: [ 
					(self list at: listIndex) archived: true.
					self changed: #list.
					listIndex := 0.
					self changed: #listIndex.
					model2 := nil.
					self changed: #list2.
					listIndex2 := 0.
					self changed: #listIndex2.
					model3 := nil.
					self changed: #list3 ] ]! !

!PirateManagerMorph methodsFor: 'event handling' stamp: 'ChristerAssmundsson 4/7/2014 22:17'!
dblClick
	"self inform: 'dubbelclickade'."
	listIndex > 0
		ifTrue: [
			model2 := self list at: listIndex.
			self changed: #list2.
			self listIndex2: 0.
			model3 := nil.
			self changed: #list3 ]! !

!PirateManagerMorph methodsFor: 'event handling' stamp: 'ChristerAssmundsson 9/14/2012 21:11'!
dblClick2
	"self inform: 'dubbelclickade'."
	listIndex2 > 0
		ifTrue: [model3 := model2 seasons at: listIndex2.
			self changed: #list3.		
			listIndex3 := 0.
			self changed: #listIndex3.]! !

!PirateManagerMorph methodsFor: 'event handling' stamp: 'CAs 6/18/2012 07:42'!
dblClick3
	| m ep |
	listIndex3 > 0
		ifTrue: [m := PirateEpisodeMorph new.
			ep := model3 episodes at: listIndex3.
			m model: ep.
			m openInWorld.
			]! !

!PirateManagerMorph methodsFor: 'event handling' stamp: 'ChristerAssmundsson 5/18/2014 08:53'!
deleteShow
	listIndex > 0
		ifTrue: [ 
			(self confirm: 'Villdu verkligen ta bort programmet?' , String crlfcrlf , (self list at: listIndex) name)
				ifTrue: [ 
					PirateShow removeShow: (self list at: listIndex).
					self changed: #list.
					listIndex := 0.
					self changed: #listIndex.
					model2 := nil.
					self changed: #list2.
					listIndex2 := 0.
					self changed: #listIndex2.
					model3 := nil.
					self changed: #list3 ] ]! !

!PirateManagerMorph methodsFor: 'model access' stamp: 'ChristerAssmundsson 3/18/2015 07:37'!
getEpisodeText: anEpisode
"self halt."

	^ {(anEpisode id).
	(anEpisode found
		ifTrue: [ 'found' ]
		ifFalse: [ ' - ' ]).
	(anEpisode newFound
		ifTrue: [ 'new' ]
		ifFalse: [ ' - ' ]).	"(anEpisode isDownloaded)ifTrue:['downloaded']ifFalse:[
		anEpisode torrent isNil ifTrue: [' - '] ifFalse: ['started']]."
	(anEpisode status).
	(anEpisode statusCode printString).
	(anEpisode isViewable 
		ifTrue: [ 'viewable' ]
		ifFalse: [ ' - ' ]).
	(anEpisode hasSubtitle
		ifTrue: [ 'subs' ]
		ifFalse: [ ' - ' ]).
	(anEpisode isViewed
		ifTrue: [ 'seen' ]
		ifFalse: [ ' - ' ])}! !

!PirateManagerMorph methodsFor: 'model access' stamp: 'ChristerAssmundsson 9/14/2012 21:05'!
getSeasonText: aSeason
	^aSeason id.! !

!PirateManagerMorph methodsFor: 'model access' stamp: 'ChristerAssmundsson 9/3/2012 07:09'!
getShowText: aShow
	^{
		aShow name.
		(aShow newEpisodeCount) > 0 ifTrue:['new'] ifFalse:['-'].
		(aShow notSeenCount) > 0 ifTrue:['viewable'] ifFalse:['-'].
	}! !

!PirateManagerMorph methodsFor: 'initialize-release' stamp: 'CAs 4/16/2012 07:01'!
initialize
	model := PirateShow shows.
	super initialize.
! !

!PirateManagerMorph methodsFor: 'model access' stamp: 'ChristerAssmundsson 1/31/2014 23:35'!
list
	model ifNil: [ ^ nil ].	
	^ model reject: [ :item | item archived ]! !

!PirateManagerMorph methodsFor: 'model access' stamp: 'ChristerAssmundsson 1/31/2014 23:44'!
list2
	model2
		ifNil: [^ nil].
	^model2 seasons! !

!PirateManagerMorph methodsFor: 'model access' stamp: 'ChristerAssmundsson 1/31/2014 23:45'!
list3
	model3 ifNil: [ ^ nil ].
	^ model3 episodes! !

!PirateManagerMorph methodsFor: 'model access' stamp: 'CAs 4/16/2012 07:02'!
listIndex
	^listIndex ifNil: [listIndex:=0].! !

!PirateManagerMorph methodsFor: 'model access' stamp: 'CAs 4/27/2012 06:59'!
listIndex2
	^ listIndex2
		ifNil: [listIndex2 := 0]! !

!PirateManagerMorph methodsFor: 'model access' stamp: 'CAs 5/19/2012 10:50'!
listIndex2: anInteger 
	listIndex2 := anInteger.
	self changed: #listIndex2.	
		self dblClick2! !

!PirateManagerMorph methodsFor: 'model access' stamp: 'CAs 4/30/2012 07:03'!
listIndex3
	^ listIndex3
		ifNil: [listIndex3 := 0]! !

!PirateManagerMorph methodsFor: 'model access' stamp: 'CAs 4/30/2012 07:03'!
listIndex3: anInteger 
	listIndex3 := anInteger.
	self changed: #listIndex3! !

!PirateManagerMorph methodsFor: 'model access' stamp: 'ChristerAssmundsson 9/14/2012 21:31'!
listIndex: anInteger
	listIndex := anInteger.
	self changed: #listIndex.
	self dblClick! !

!PirateManagerMorph methodsFor: 'event handling' stamp: 'ChristerAssmundsson 6/23/2013 15:33'!
lookForNew
	[PirateShow shows
		do: [:sh | sh lookForAll].
	PirateShow writeToFile .
	Transcript show: '-------------'; cr.
	self changed: #list] fork.! !

!PirateManagerMorph methodsFor: 'event handling' stamp: 'ChristerAssmundsson 3/18/2013 07:02'!
newEpisodes
	| m ep |
	m := PirateNewMorph new.
	m model: model.
	m openInWorld.! !

!PirateManagerMorph methodsFor: 'event handling' stamp: 'ChristerAssmundsson 12/10/2013 04:12'!
pairing
	PiratePairingEditor new open.! !

!PirateManagerMorph methodsFor: 'event handling' stamp: 'ChristerAssmundsson 5/31/2014 23:27'!
play
	| ep |
	listIndex3 > 0
		ifTrue: [
			ep := model3 episodes at: listIndex3.
			ep isDownloaded ifTrue: [
				ep play.
				(self confirm: 'Did you see the entire show?') ifTrue: [
					[ep viewed.				
					self changed: #list1.
					self changed: #list3 ] forkAt: Processor userBackgroundPriority .		
				].
"				(self confirm: 'Subtitles OK?') ifTrue: ["
"					ep viewed."	"]."
			].
		]! !

!PirateManagerMorph methodsFor: 'event handling' stamp: 'ChristerAssmundsson 1/28/2013 20:48'!
refresh
	Cursor wait showWhile: [
		PirateTorrent updateStatuses .
		self changed: #list.
		self changed: #list3 .
		"PirateTorrent cleanUpSeedingDoneOnce."
		Transcript show: '-------------'; cr.
	].
	! !

!PirateManagerMorph methodsFor: 'event handling' stamp: 'ChristerAssmundsson 9/3/2012 07:05'!
removeEpisode
	| rc |
	listIndex > 0 ifTrue: [
			(self confirm: 'Vill du verkligen ta bort avsnittet?') ifTrue: [
				self changed: #list3.
				self changed: #listIndex3.
				]
			].! !

!PirateManagerMorph methodsFor: 'event handling' stamp: 'ChristerAssmundsson 1/31/2014 23:38'!
removeSeen
	[
		self refresh.
		PirateTorrent cleanUpSeedingDoneOnce.
		Transcript show: '-------------'; cr.
	] forkAt: Processor userBackgroundPriority .		
	! !

!PirateManagerMorph methodsFor: 'event handling' stamp: 'ChristerAssmundsson 11/17/2013 23:59'!
seenEpisode
	| ep |
	listIndex3 > 0
		ifTrue: [
			ep := model3 episodes at: listIndex3.
			ep isViewed 
				ifTrue: [ep unViewed ]
				ifFalse: [ep viewed].
			self changed: #list1.
			self changed: #list3			
		]! !

!PirateManagerMorph methodsFor: 'event handling' stamp: 'ChristerAssmundsson 3/4/2015 07:20'!
test
	| ep magnet t |
	listIndex3 = 0
		ifTrue: [ ^ self ].
	ep := model3 episodes at: listIndex3.
	magnet := UIManager default request: 'Magnet'.
	magnet = ''
		ifTrue: [ ^ self ].
	t := PirateTorrent magnet: magnet.
	ep
		torrent: t;
		download! !

!PirateManagerMorph methodsFor: 'event handling' stamp: 'ChristerAssmundsson 3/15/2013 06:59'!
testDeleteSubtitles
	| m ep |
	listIndex3 > 0
		ifTrue: [
			ep := model3 episodes at: listIndex3.
			ep deleteSubtitles.
		]! !

!PirateManagerMorph methodsFor: 'event handling' stamp: 'ChristerAssmundsson 3/18/2013 06:58'!
viewables
	| m ep |
	m := PirateViewableMorph new.
	m model: model.
	m openInWorld.! !

!PirateManagerMorph methodsFor: 'event handling' stamp: 'ChristerAssmundsson 9/3/2012 06:58'!
writeToFile
	Cursor wait showWhile: [PirateShow writeToFile].
	^self ! !

BlocketRootMorph subclass: #PirateMovieMorph
	instanceVariableNames: 'shows listIndex model'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CAs-Pirate-Gui'!

BlocketRootMorph subclass: #PirateNewMorph
	instanceVariableNames: 'shows listIndex model'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CAs-Pirate-Gui'!

!PirateNewMorph methodsFor: 'as yet unclassified' stamp: 'ChristerAssmundsson 3/18/2013 07:04'!
addControls
	| r lst btnPanel morph |
	self
		addMorphBack: (StringMorph contents: 'Title: ').

	lst := PluggableMultiColumnListMorph
				on: self
				list: #list
				selected: #listIndex
				changeSelected: #listIndex:.
		"		menu: #listMenu:."
	lst doubleClickSelector: #dblClick.
	lst wrapSelector: #getEpisodeText:  .
	lst color: Color white.
	lst extent: 400 @ 500.
	self addMorphBack: lst.
	
	btnPanel := self newRow.
	btnPanel color: Color transparent;
		 borderWidth: 0;
		 layoutInset: 2;
		 wrapCentering: #center;
		 cellPositioning: #topCenter;
		 hResizing: #shrinkWrap;
		 vResizing: #shrinkWrap;
		 extent: 5 @ 5.
	self addMorphBack: btnPanel.
	btnPanel
		addMorphBack: (self newButton: 'Refresh' do: #refresh).
"	btnPanel
		addMorphBack: (self newButton: 'Play' do: #play).
	btnPanel
		addMorphBack: (self newButton: 'Subtitles...' do: #subtitles).
"	"------------------------------------"
	r := AlignmentMorph newRow color: Color transparent;
				 borderWidth: 0;
				 layoutInset: 0.
	r wrapCentering: #center;
		 cellPositioning: #topCenter;
		 hResizing: #shrinkWrap;
		 vResizing: #shrinkWrap;
		 extent: 5 @ 5.
	r
		addMorphBack: (self newButton: 'Close' do: #delete).
	r addTransparentSpacerOfSize: 8 @ 0.
	self addMorphFront: r! !

!PirateNewMorph methodsFor: 'as yet unclassified' stamp: 'ChristerAssmundsson 3/18/2013 22:16'!
dblClick
	self open ! !

!PirateNewMorph methodsFor: 'as yet unclassified' stamp: 'ChristerAssmundsson 3/18/2013 07:00'!
getEpisodeText: anEpisode

 ^{anEpisode season show name.
	anEpisode season id.
	anEpisode id. 
	(anEpisode hasSubtitle)ifTrue:['subs']ifFalse:[' - '].
	}.! !

!PirateNewMorph methodsFor: 'as yet unclassified' stamp: 'ChristerAssmundsson 3/18/2013 07:00'!
icon
	^ nil! !

!PirateNewMorph methodsFor: 'as yet unclassified' stamp: 'ChristerAssmundsson 3/18/2013 07:00'!
initialize
	super initialize.! !

!PirateNewMorph methodsFor: 'as yet unclassified' stamp: 'ChristerAssmundsson 3/18/2013 07:01'!
list
	model
		ifNil: [^ nil].
	^ model! !

!PirateNewMorph methodsFor: 'as yet unclassified' stamp: 'ChristerAssmundsson 3/18/2013 07:01'!
listIndex
	^ listIndex
		ifNil: [listIndex := 0]! !

!PirateNewMorph methodsFor: 'as yet unclassified' stamp: 'ChristerAssmundsson 3/18/2013 07:01'!
listIndex: aSmallInteger 
	listIndex := aSmallInteger.
	self changed: #listIndex.
	! !

!PirateNewMorph methodsFor: 'as yet unclassified' stamp: 'ChristerAssmundsson 3/18/2013 07:01'!
model:  allShows 
	shows := allShows.
	self refresh.
! !

!PirateNewMorph methodsFor: 'as yet unclassified' stamp: 'ChristerAssmundsson 3/18/2013 22:15'!
open
	| m ep |
	listIndex > 0
		ifTrue: [m := PirateEpisodeMorph new.
			ep := model at: listIndex.
			m model: ep.
			m openInWorld.
			]! !

!PirateNewMorph methodsFor: 'as yet unclassified' stamp: 'ChristerAssmundsson 3/18/2013 07:05'!
refresh
	| tmp |
	model := OrderedCollection new.
	tmp := shows collect: [:s|s newEpisode].
	model := tmp reject: [:i| i isNil].
	self changed: #list.
! !

BlocketRootMorph subclass: #PirateSubtitleMorph
	instanceVariableNames: 'model listEn listIndexEn listSwe listIndexSwe'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CAs-Pirate-Gui'!

!PirateSubtitleMorph methodsFor: 'as yet unclassified' stamp: 'ChristerAssmundsson 2/25/2015 07:32'!
addControls
	| r lst btnPanel |
	self addMorphBack: (StringMorph contents: 'Title: ').	"self
	addMorph: (PluggableTextMorph
	on: nil
	text: #getTitle
	accept: #setTitle)."
	lst := PluggableMultiColumnListMorph
		on: self
		list: #listEn
		selected: #listIndexEn
		changeSelected: #listIndexEn:
		menu: #listMenu:.
	lst doubleClickSelector: #dblClick.
	lst wrapSelector: #getSubColumn:.
	lst color: Color white.
	lst extent: 500 @ 130.
	self addMorphBack: lst.
	lst := PluggableMultiColumnListMorph
		on: self
		list: #listSwe
		selected: #listIndexSwe
		changeSelected: #listIndexSwe:
		menu: #listMenu:.
	lst doubleClickSelector: #dblClick.
	lst wrapSelector: #getSubColumn:.
	lst color: Color white.
	lst extent: 500 @ 130.
	self addMorphBack: lst.
	btnPanel := self newRow.
	btnPanel
		color: Color transparent;
		borderWidth: 0;
		layoutInset: 2;
		wrapCentering: #center;
		cellPositioning: #topCenter;
		hResizing: #shrinkWrap;
		vResizing: #shrinkWrap;
		extent: 5 @ 5.
	self addMorphBack: btnPanel.
	btnPanel addMorphBack: (self newButton: 'Refresh.' do: #getSubtitles).
	btnPanel addMorphBack: (self newButton: 'Download' do: #setSub).
	self addMorphBack: (self newButton: 'temp' do: #temp).	"------------------------------------"
	r := AlignmentMorph newRow
		color: Color transparent;
		borderWidth: 0;
		layoutInset: 0.
	r
		wrapCentering: #center;
		cellPositioning: #topCenter;
		hResizing: #shrinkWrap;
		vResizing: #shrinkWrap;
		extent: 5 @ 5.
	r addMorphBack: (self newButton: 'Close' do: #delete).
	r addTransparentSpacerOfSize: 8 @ 0.
	self addMorphFront: r! !

!PirateSubtitleMorph methodsFor: 'model access' stamp: 'ChristerAssmundsson 9/14/2012 20:58'!
dblClick
	self setSub.
	self delete.! !

!PirateSubtitleMorph methodsFor: 'model access' stamp: 'ChristerAssmundsson 1/2/2014 00:12'!
downloadSub: subDict
	| os |
	Cursor wait showWhile: [os := OpenSubClient current.
		os login.
		os downloadSubtitle: subDict fileName: (model videoFile fullVideoFilename ).
		os logout.]! !

!PirateSubtitleMorph methodsFor: 'model access' stamp: 'CAs 6/25/2012 11:47'!
findCurrentSub
! !

!PirateSubtitleMorph methodsFor: 'as yet unclassified' stamp: 'ChristerAssmundsson 2/12/2013 20:44'!
getSubColumn: sub
	^ {sub at: #MovieName.
		(sub at: #SeriesSeason) , '->',
		(sub at: #SeriesEpisode).
		sub at: #SubRating.
		sub at: #SubDownloadsCnt.
		(sub at: #SubHearingImpaired) = '1'
			ifTrue:['HI']
			ifFalse:['-'].
		sub at: #MatchedBy	
		}! !

!PirateSubtitleMorph methodsFor: 'model access' stamp: 'ChristerAssmundsson 11/25/2013 07:27'!
getSubtitles
	| |
	model
		ifNil: [^ self].
	Cursor wait showWhile: [
		listEn := model subtitles: 'eng'.	
		listEn := listEn .
		self changed: #listEn.
		listIndexEn := 0.

		listSwe := model subtitles: 'swe'.
		listSwe := listSwe .
		self changed: #listSwe.
		listIndexSwe := 0.
	].! !

!PirateSubtitleMorph methodsFor: 'model access' stamp: 'CAs 7/11/2012 07:53'!
getSubtitlesOld
	| allSubs |
	model
		ifNil: [^ self].
	"["
	allSubs := model getSubtitles.self halt.
	listEn := allSubs
				reject: [:i | (i at: 1)
						includesSubstring: 'swesub'
						caseSensitive: false].
	self changed: #listEn.
	listIndexEn := 0.
	listSwe := allSubs
				select: [:i | (i at: 1)
						includesSubstring: 'swesub'
						caseSensitive: false].
	self changed: #listSwe.
	listIndexSwe := 0.
	WorldState
		addDeferredUIMessage: [self findCurrentSub
			"] fork"]! !

!PirateSubtitleMorph methodsFor: 'model access' stamp: 'CAs 7/16/2012 21:33'!
listEn
	listEn ifNil: [^ nil].
	listEn isArray 
		ifTrue: [^ listEn]
		ifFalse: [^ nil].
		"collect: [:f | listEn
				collect: [:i | i at: f]]"! !

!PirateSubtitleMorph methodsFor: 'model access' stamp: 'CAs 6/25/2012 11:35'!
listIndexEn
	^ listIndexEn
		ifNil: [listIndexEn := 0]! !

!PirateSubtitleMorph methodsFor: 'model access' stamp: 'CAs 7/17/2012 07:44'!
listIndexEn: aSmallInteger 
	listIndexEn := aSmallInteger.
	self changed: #listIndexEn.
	listIndexSwe:=0.
	self changed: #listIndexSwe.! !

!PirateSubtitleMorph methodsFor: 'model access' stamp: 'CAs 6/25/2012 11:35'!
listIndexSwe
	^ listIndexSwe
		ifNil: [listIndexSwe := 0]! !

!PirateSubtitleMorph methodsFor: 'model access' stamp: 'CAs 7/17/2012 07:45'!
listIndexSwe: aSmallInteger 
	listIndexSwe:=aSmallInteger.
	self changed: #listIndexSwe.
	listIndexEn := 0.
	self changed: #listIndexEn.
! !

!PirateSubtitleMorph methodsFor: 'model access' stamp: 'CAs 7/16/2012 21:38'!
listSwe
	listSwe
		ifNil: [^ nil].
	listSwe isArray
		ifTrue: [^listSwe]
		ifFalse: [^ nil].! !

!PirateSubtitleMorph methodsFor: 'model access' stamp: 'CAs 6/25/2012 11:38'!
model: anEpisode 
	model := anEpisode.
	self getSubtitles! !

!PirateSubtitleMorph methodsFor: 'model access' stamp: 'ChristerAssmundsson 9/3/2012 06:59'!
setSub
	| t |
	self listIndexEn > 0
		ifTrue: [t := listEn at: listIndexEn].
	self listIndexSwe > 0
		ifTrue: [t := listSwe at: listIndexSwe].
	t isNil
		ifFalse: [
			self downloadSub: t.
			model setSub: t]! !

!PirateSubtitleMorph methodsFor: 'as yet unclassified' stamp: 'ChristerAssmundsson 9/1/2012 09:58'!
temp
	| out err desc args proc |
	self halt.
	out := FileStream forceNewFileNamed: '/tmp/deleteMe.out'.
	err := FileStream forceNewFileNamed: '/tmp/deleteMe.err'.
	desc := Array
				with: nil
				with: out
				with: err.
	args := Array
				with: '--fullscreen'
				with: '/media/cm1store/Torrent/Girls.S01E01.HDTV.x264-ASAP.mp4'.
	proc := UnixProcess
				forkJob: '/usr/bin/vlc'
				arguments: args
				environment: nil
				descriptors: desc.
	proc ifNil: [UnixProcess noAccessorAvailable].
	[proc isComplete] whileFalse:
		[(Delay forMilliseconds: 200) wait.].
	out close.
	err close.
	self inform: 'klart!!!!'.
	^ proc
"	^ self"! !

BlocketRootMorph subclass: #PirateViewableMorph
	instanceVariableNames: 'shows listIndex model showsStarted'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CAs-Pirate-Gui'!

!PirateViewableMorph methodsFor: 'as yet unclassified' stamp: 'ChristerAssmundsson 6/30/2013 01:15'!
addControls
	| r lst btnPanel morph started |
	started := CheckboxMorph on: self selected: #showsStarted changeSelected: #showStarted.
	started label: 'Show only started'.
	started height: 20.
	self addMorphBack: started.
	lst := PluggableMultiColumnListMorph
				on: self
				list: #list
				selected: #listIndex
				changeSelected: #listIndex:.
		"		menu: #listMenu:."
	lst doubleClickSelector: #dblClick.
	lst wrapSelector: #getEpisodeText:  .
	lst color: Color white.
	lst extent: 400 @ 400.
	self addMorphBack: lst.
	
	btnPanel := self newRow.
	btnPanel color: Color transparent;
		 borderWidth: 0;
		 layoutInset: 2;
		 wrapCentering: #center;
		 cellPositioning: #topCenter;
		 hResizing: #shrinkWrap;
		 vResizing: #shrinkWrap;
		 extent: 5 @ 5.
	self addMorphBack: btnPanel.
	btnPanel
		addMorphBack: (self newButton: 'Refresh' do: #refresh).
	btnPanel
		addMorphBack: (self newButton: 'Play' do: #play).
	btnPanel
		addMorphBack: (self newButton: 'Subtitles...' do: #subtitles).
	btnPanel
		addMorphBack: (self newButton: 'Top Sub' do: #topSubtitles).
	"------------------------------------"
	r := AlignmentMorph newRow color: Color transparent;
				 borderWidth: 0;
				 layoutInset: 0.
	r wrapCentering: #center;
		 cellPositioning: #topCenter;
		 hResizing: #shrinkWrap;
		 vResizing: #shrinkWrap;
		 extent: 5 @ 5.
	r
		addMorphBack: (self newButton: 'Close' do: #delete).
	r addTransparentSpacerOfSize: 8 @ 0.
	self addMorphFront: r! !

!PirateViewableMorph methodsFor: 'as yet unclassified' stamp: 'ChristerAssmundsson 1/13/2013 19:57'!
dblClick
	"	self inform: 'dubbelclickade'."
	listIndex > 0
		ifTrue: [ self play ]! !

!PirateViewableMorph methodsFor: 'as yet unclassified' stamp: 'ChristerAssmundsson 11/21/2012 07:04'!
getEpisodeText: anEpisode

 ^{anEpisode season show name.
	anEpisode season id.
	anEpisode id. 
	(anEpisode hasSubtitle)ifTrue:['subs']ifFalse:[' - '].
	}.! !

!PirateViewableMorph methodsFor: 'as yet unclassified' stamp: 'ChristerAssmundsson 12/2/2012 23:18'!
icon
	^ nil! !

!PirateViewableMorph methodsFor: 'as yet unclassified' stamp: 'ChristerAssmundsson 11/9/2012 22:48'!
initialize
	super initialize.! !

!PirateViewableMorph methodsFor: 'as yet unclassified' stamp: 'ChristerAssmundsson 11/16/2012 23:48'!
list
	model
		ifNil: [^ nil].
	^ model! !

!PirateViewableMorph methodsFor: 'as yet unclassified' stamp: 'ChristerAssmundsson 11/9/2012 22:51'!
listIndex
	^ listIndex
		ifNil: [listIndex := 0]! !

!PirateViewableMorph methodsFor: 'as yet unclassified' stamp: 'ChristerAssmundsson 11/9/2012 22:51'!
listIndex: aSmallInteger 
	listIndex := aSmallInteger.
	self changed: #listIndex.
	! !

!PirateViewableMorph methodsFor: 'as yet unclassified' stamp: 'ChristerAssmundsson 1/13/2013 16:57'!
model:  allShows 
	shows := allShows.
	self refresh.
! !

!PirateViewableMorph methodsFor: 'as yet unclassified' stamp: 'ChristerAssmundsson 6/30/2013 01:55'!
play
	| ep |
	(self listIndex = 0) ifTrue: [^self].
	ep := model at: listIndex.
	ep isDownloaded
		ifTrue: [ 
			ep play.
			(self confirm: 'Did you see the entire show?')
				ifTrue: [ 
					[ 
"					(self confirm: 'Subtitles OK?')
				ifTrue: [  ].
"					ep viewed.
					self refresh.
					self changed: #list ] forkAt: Processor userBackgroundPriority ].
			 ]! !

!PirateViewableMorph methodsFor: 'as yet unclassified' stamp: 'ChristerAssmundsson 4/3/2013 06:38'!
refresh
	| tmp |
	model := OrderedCollection new.
	tmp := shows collect: [:s|s nextEpisode].
	tmp := tmp reject: [:i| i isNil].
	self showsStarted ifTrue: [
		tmp := tmp reject: [:i|
			(i id = '01') and: [i season id = '01']
			]
		].
	model:= tmp.
	self changed: #list.
 ! !

!PirateViewableMorph methodsFor: 'as yet unclassified' stamp: 'ChristerAssmundsson 4/3/2013 06:33'!
showStarted
	showsStarted :=self showsStarted not.
	self refresh.! !

!PirateViewableMorph methodsFor: 'as yet unclassified' stamp: 'ChristerAssmundsson 4/4/2013 06:27'!
showsStarted
	showsStarted
		ifNil: [showsStarted := true].
	^ showsStarted! !

!PirateViewableMorph methodsFor: 'as yet unclassified' stamp: 'ChristerAssmundsson 6/30/2013 01:55'!
subtitles
	| ep m |
		(self listIndex = 0) ifTrue: [^self].

	ep := model at: listIndex.

	ep isDownloaded
		ifTrue: [ 
			m:=PirateSubtitleMorph new.
			m model: ( ep).
			m openInWorld.
			self changed: #list			 
		]! !

!PirateViewableMorph methodsFor: 'as yet unclassified' stamp: 'ChristerAssmundsson 4/12/2014 09:51'!
topSubtitles
	| ep |
	self listIndex = 0
		ifTrue: [ ^ self ].
	ep := model at: listIndex.
	ep isDownloaded
		ifTrue: [ 
			ep topSubtitles.
			self changed: #list ]! !

Object subclass: #PiratePairingEditor
	instanceVariableNames: 'videos files torrent show selectionIndexFiles selectionIndexVideos'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CAs-Pirate-Gui'!

!PiratePairingEditor methodsFor: 'as yet unclassified' stamp: 'ChristerAssmundsson 12/20/2013 07:14'!
canConnect
	^(selectionIndexVideos > 0) and: [ selectionIndexFiles > 0 ]! !

!PiratePairingEditor methodsFor: 'as yet unclassified' stamp: 'ChristerAssmundsson 12/20/2013 07:45'!
connectButtonClick
	self selectedVideo videoFile: (self selectedFile ).
	self selectedFile video: (self selectedVideo ).
	
	self changed: #listVideos.
	self changed: #listFiles.! !

!PiratePairingEditor methodsFor: 'as yet unclassified' stamp: 'ChristerAssmundsson 12/10/2013 23:45'!
getFileName: aVideoFile 	
	^aVideoFile videoFilename.! !

!PiratePairingEditor methodsFor: 'as yet unclassified' stamp: 'ChristerAssmundsson 12/17/2013 07:09'!
getVideoName: anEpisode
	^anEpisode fullId.! !

!PiratePairingEditor methodsFor: 'as yet unclassified' stamp: 'ChristerAssmundsson 12/13/2013 20:39'!
initialize
	super initialize.
	self selectionIndexFiles: 0.
	self selectionIndexVideos: 0! !

!PiratePairingEditor methodsFor: 'as yet unclassified' stamp: 'ChristerAssmundsson 12/13/2013 20:54'!
inspectVideo
	self selectedVideo explore.! !

!PiratePairingEditor methodsFor: 'as yet unclassified' stamp: 'ChristerAssmundsson 12/20/2013 07:19'!
listFiles
	files := self torrent videoFiles.
	^ files select: [ :vf | vf video isNil ].
! !

!PiratePairingEditor methodsFor: 'as yet unclassified' stamp: 'ChristerAssmundsson 12/20/2013 07:43'!
listVideos
	| seasons available |
	seasons := self show seasons.
	videos := OrderedCollection new.
	seasons do: [ :s | videos addAll: s episodes ].
	available := videos select: [ :e | e videoFile isNil ].
	^ available! !

!PiratePairingEditor methodsFor: 'as yet unclassified' stamp: 'ChristerAssmundsson 12/20/2013 07:03'!
open
	| builder content |
	builder := UITheme builder.
	content := builder
		newColumn:
			{((builder
				newRow:
					{((builder
						newListFor: self
						list: #listVideos
						selected: #selectionIndexVideos
						changeSelected: #selectionIndexVideos:
						help: 'This is a list')
						minWidth: 190;
						wrapSelector: #getVideoName:).
					((builder
						newListFor: self
						list: #listFiles
						selected: #selectionIndexFiles
						changeSelected: #selectionIndexFiles:
						help: 'This is a list')
						minWidth: 190;
						wrapSelector: #getFileName:)}) vResizing: #spaceFill).	"			(builder
				newListFor: self
				list: #contacts
				selected: #contactSelectedIndex
				changeSelected: #contactSelectedIndex:
				help: 'contacts')."
			(builder
				newRow:
					{(builder
						newButtonFor: self
						action: #connectButtonClick
						getEnabled: #canConnect
						label: 'Connect'
						help: 'Create a new contact').
					(builder
						newButtonFor: self
						action: #removeButtonClick
						getEnabled: nil
						label: 'Remove'
						help: 'Remove selected contact').
					(builder
						newButtonFor: self
						action: #inspectVideo
						getEnabled: nil
						label: 'Inspect Video'
						help: 'Remove selected contact').
					(builder
						newButtonFor: self
						action: #inspectFile
						getEnabled: nil
						label: 'Inspect File'
						help: 'Remove selected contact')	"					(builder
						newButtonFor: self
						action: #editButtonClick
						getEnabled: #hasSelectedContact
						label: 'Edit'
						help: 'Edit selected contact')"})}.
	(content openInWindowLabeled: 'Contacts') extent: 600 @ 500! !

!PiratePairingEditor methodsFor: 'as yet unclassified' stamp: 'ChristerAssmundsson 12/20/2013 07:20'!
selectedFile
	"Answer the currently selected item or nil if none."

	^self selectionIndexFiles = 0
		ifTrue: [nil]
		ifFalse: [self listFiles at: self selectionIndexFiles]! !

!PiratePairingEditor methodsFor: 'as yet unclassified' stamp: 'ChristerAssmundsson 12/13/2013 20:53'!
selectedVideo
	"Answer the currently selected item or nil if none."

	^self selectionIndexVideos  = 0
		ifTrue: [nil]
		ifFalse: [self listVideos at: self selectionIndexVideos]! !

!PiratePairingEditor methodsFor: 'as yet unclassified' stamp: 'ChristerAssmundsson 12/13/2013 20:46'!
selectionIndexFiles
	"Answer the value of selectionIndex"

	^ selectionIndexFiles! !

!PiratePairingEditor methodsFor: 'as yet unclassified' stamp: 'ChristerAssmundsson 12/20/2013 07:13'!
selectionIndexFiles: anObject
	"Set the value of selectionIndex"

	selectionIndexFiles := anObject.
	self changed: #selectionIndexFiles.
	self changed: #canConnect.! !

!PiratePairingEditor methodsFor: 'as yet unclassified' stamp: 'ChristerAssmundsson 12/13/2013 20:46'!
selectionIndexVideos
	"Answer the value of selectionIndex"

	^ selectionIndexVideos! !

!PiratePairingEditor methodsFor: 'as yet unclassified' stamp: 'ChristerAssmundsson 12/20/2013 07:13'!
selectionIndexVideos: anObject
	"Set the value of selectionIndex"

	selectionIndexVideos := anObject.
	self changed: #selectionIndexVideos.
	self changed: #canConnect.! !

!PiratePairingEditor methodsFor: 'as yet unclassified' stamp: 'ChristerAssmundsson 12/17/2013 07:00'!
show
	^PirateShow at: 'Coupling'! !

!PiratePairingEditor methodsFor: 'as yet unclassified' stamp: 'ChristerAssmundsson 12/17/2013 06:53'!
torrent
	| t |
	t:= PirateTorrent at: '959b3ac4196f2eaa3102abb52bc3d81742e74734'.
	^t! !
